/***************************************************************

  BayCom(R)        Packet-Radio fuer IBM PC

  OpenBayCom-Mailbox

  ---------------------
  Pocsag-Server for BCM
  ---------------------


  Copyright (C)  Patrick, DF3VI
  Auf Grundlage des Maillistservers von Jonny, DH3MB

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/
//20010915 DK2UI  some corrections
//20030410 DH6BB  User mit SSID auch anpagebar.
//20030506 DH6BB  BugFix im SSID-Teil

#include "baycom.h"

#ifdef DF3VI_POCSAG

/*---------------------------------------------------------------------------*/

void pocsagserv::parse_listheader (char *line, char **name, char **description)
//*************************************************************************
//
//  Extracts the data from a pocsag server list header and stores the field
//  to the according pointers
//
//*************************************************************************
// eg: DB0KOE DESCRIPTION
{ *name = line;
  rm_crlf (line);
  if ((*description = strchr (*name, ' ')) != 0)
  { **description = 0;
    while (*(++*description) == ' ') **description = 0;
  }
  else *description = line + strlen (line);
  if (**description)
    while ((*description)[strlen (*description) - 1] == ' ')
      (*description)[strlen(*description) - 1] = 0;
}

/*---------------------------------------------------------------------------*/

char pocsagserv::seek_list (FILE *fold, FILE *f, char what, char *parameter, char *user)
//*************************************************************************
//
//  Moves the file-pointer to the searched string and copies the
//  file to f, if f!=0
//
//  If searching an entry, the file-pointer must point to the header
//  of the pocsag server list
//
//*************************************************************************
{ char s[128], line[128];
  static char server[CALLEN+1];
  char *s2;
  long posbuf;

  if (what == pocsag_seek_user)
  { fgets (line, 127, fold);
    if (f) fprintf (f, "%s", line);
  }
  posbuf = ftell (fold);
  while ( ! feof (fold) && fgets (line, 127, fold))
  { strcpy (s, line);
    rm_crlf (s);
    switch (what)
    {
    case pocsag_seek_entry:
      if (*s != ' ')
      { if ((s2 = strchr (s, ' ')) != 0) *s2++ = 0;
        strcpy (server, s);
      }
      else
      { while (*s == ' ') strcpy (s, s+1);
        if (strchr (s, ' ')) *strchr (s, ' ') = 0;
        strupr (s);
        strcpy (user, s); // user mit SSID sichern
        subst(s,'-',0);  // SSID zum vergleich abtrennen
        if ( ! stricmp (s, parameter))
        { // Position hier NICHT zuruecksetzen!!!
          strcpy (parameter, server);
          return OK; // server;
        }
        user[0]=0;
      }
      break;
    case pocsag_seek_server:
      if (*s != ' ')
      { if ((s2 = strchr (s, ' ')) != 0) *s2++ = 0;
        if ( ! stricmp (s, parameter))
        { fseek (fold, posbuf, SEEK_SET);
          return OK; // parameter;
        }
      }
      if (f) fprintf (f, "%s", line);
      break;
    case pocsag_seek_user:
      if (*s == ' ')
      { while (*s == ' ') strcpy (s, s+1);
        if (strchr (s, ' ')) *strchr (s, ' ') = 0;
        strupr (s);
        if ( ! stricmp (s, parameter))
        { fseek (fold, posbuf, SEEK_SET);
          return OK; // parameter;
        }
        else if (f) fprintf (f, "%s", line);
      }
      else
      { fseek (fold, posbuf, SEEK_SET);
        return NO;
      }
      break;
    case pocsag_seek_end:
      if (f) fprintf (f, "%s", line);
      break;
    default:
      trace (serious, "pocsagserver", "invalid seek-code");
      break;
    }
    posbuf = ftell (fold);
    waitfor (e_ticsfull);
  }
  return NO;
}

/*---------------------------------------------------------------------------*/

void pocsagserv::modify_list (char what, char *servername, char *parameter)
//*************************************************************************
//
//  Changes something in the pocsag server list settings
//
//*************************************************************************
{
  char nexis[] = "A pocsag server named %s does not exist.\n";
  char buffer[90];
  char *name, *description;

//trace(report,"pocsagsv","lock 934");
  while ( ! sema_lock (POCSAGSEMA)) wdelay (934);
  FILE *f = s_fopen (POCSAGLISTTMP, "swt");
  if (f) s_fsetopt (f, 1);
  else trace (fatal, "pogsagsv:mod", "nopen tmp-file");
  FILE *fold = s_fopen (POCSAGLISTNAME, "srt");
  if ( ! fold) fold = s_fopen (POCSAGLISTNAME, "swt"); //dummy for opening a file, stupid...
  if ( ! fold) trace (fatal, "pocsagsv:mod", "nopen server-list");
  switch (what)
  { case pocsag_createlist:
      if ((m.pocsaglistserv == 1) && ! b->sysop)
      { putf ("Sysop only.\n");
        break;
      }
      if (seek_list (fold, f, pocsag_seek_server, servername, ""))
        putf ("A server %s already exists.\n", servername);
      else
      { fprintf (f, "%s\n", servername);
        putf ("The server %s has been created.\n", servername);
      }
      break;
    case pocsag_deletelist:
      if ( ! b->sysop)
      { putf ("Sysop only.\n");
        break;
      }
      if (seek_list (fold, f, pocsag_seek_server, servername, ""))
      { seek_list (fold, 0, pocsag_seek_user, "", ""); // seek to end of this list
        putf ("Server %s removed.\n", servername);
      }
      else
      { putf (nexis, servername);
//      fseek (fold, 0, SEEK_SET);
      }
      break;
    case pocsag_setdescription:
      if (seek_list (fold, 0, pocsag_seek_server, servername, ""))
      { if ( ! b->sysop)
        {
          putf ("Sysop only.\n");
          rewind (fold);
          break;
        }
        rewind (fold);
        seek_list (fold, f, pocsag_seek_server, servername, "");
        fgets (buffer, sizeof (buffer) - 1, fold);
        rm_crlf (buffer);
        parse_listheader (buffer, &name, &description);
        while (*parameter == '-') parameter++;
        parameter[60] = 0;
        fprintf (f, "%s %s\n", name, parameter);
        putf ("New description of server %s: %s\n", servername, parameter);
      }
      else
      { putf (nexis, servername);
        fseek (fold, 0, SEEK_SET);
      }
      break;
    case pocsag_subscribe:
    case pocsag_adduser:
/*
      if ( ! strchr (parameter, '@') && mbcallok (parameter))
      { get_mybbs (parameter, mybbs, 0);
        if ( ! *mybbs)
        { putf (ms (m_isunknown), parameter);
          break;
        }
      }
*/
      if (seek_list (fold, 0, pocsag_seek_server, servername, ""))
      { if (what == pocsag_adduser && ! b->sysop)
        {
          putf ("Sysop only.\n");
          rewind (fold);
          break;
        }
        rewind (fold);
        seek_list (fold, f, pocsag_seek_server, servername, "");
        if (seek_list (fold, f, pocsag_seek_user, parameter, ""))
        { if (what == pocsag_adduser)
            putf ("%s is already a user of the server %s.\n", parameter, servername);
          else
            putf ("You are already a user of the server %s.\n", servername);
        }
        else
        { fprintf (f, " %s\n", parameter);
          if (what == pocsag_adduser)
            putf ("%s is now a user of the server %s.\n", parameter, servername);
          else
            putf ("You are now a user of the server %s.\n", servername);
        }
      }
      else
      { putf (nexis, servername);
        fseek (fold, 0, SEEK_SET);
      }
      break;
    case pocsag_unsubscribe:
    case pocsag_deleteuser:
      if (seek_list (fold, 0, pocsag_seek_server, servername, ""))
      { if (what == pocsag_deleteuser && ! b->sysop)
        {
          putf ("Sysop only.\n");
          rewind (fold);
          break;
        }
        rewind (fold);
        seek_list (fold, f, pocsag_seek_server, servername, "");
        if (seek_list (fold, f, pocsag_seek_user, parameter, ""))
        { fgets (buffer, sizeof (buffer) - 1, fold);
          if (what == pocsag_deleteuser)
            putf ("User %s has been deleted from the server %s.\n", parameter, servername);
          else
            putf ("You have been deleted from the server %s.\n", servername);
        }
        else
        { if (what == pocsag_deleteuser)
            putf ("No user %s on the server %s.\n", parameter, servername);
          else
            putf ("You aren't a user of the server %s.\n", servername);
        }
      }
      else
      { putf (nexis, servername);
        fseek (fold, 0, SEEK_SET);
      }
      break;
    default:
      trace (serious, "pocsagserver", "illegal modify-code");
      break;
  }
  seek_list (fold, f, pocsag_seek_end, "", "");
  if (fold) s_fclose (fold);
  s_fclose (f);
  xunlink (POCSAGLISTNAME);
  xrename (POCSAGLISTTMP, POCSAGLISTNAME);
//trace(report,"pocsagsv","unlock 934");
  sema_unlock (POCSAGSEMA);
}

/*---------------------------------------------------------------------------*/

void pocsagserv::list_serverlists (void)
//*************************************************************************
//
//  Shows all server lists
//
//*************************************************************************
{ char s[255];
  char *p;
  int userc = 0;
//trace(report,"pocsagsv","lock 3093");
  while ( ! sema_lock (POCSAGSEMA)) wdelay (3093);
  FILE *f = s_fopen (POCSAGLISTNAME, "srt");
  if (f)
  { while (fgets (s, 255, f) || userc)
    { if (*s) rm_crlf (s);
      if (*s != ' ')
      { if (userc) putf ("Users: %4d\n", userc);
        userc = 0;
        if ((p = strchr (s, ' ') + 1) != (char *)1)
        { while (*p == ' ') p++;
          *(p - 1) = 0;
        }
        if (*s)
        { strupr (s);
          putf ("%-10s", s);
        }
        if (*s) putf ("\n");
      }
      else userc++;
      *s = 0;
      waitfor (e_ticsfull);
    }
    s_fclose (f);
  }
  else putf ("No server lists active.\n");
//trace(report,"pocsagsv","unlock 3093");
  sema_unlock (POCSAGSEMA);
}

/*---------------------------------------------------------------------------*/

void pocsagserv::show_info (char *name, char longformat)
//*************************************************************************
//
//  Shows users of a pocsag server list
//
//*************************************************************************
{ char s[256];
  char format[6];
  char cols;
  char row;
  int  userc = 0, i;
  char maxlen = 6;
  char *userlist;
  char *servername, *description;

  //do not sema-lock here, this info is read during distribution!
  FILE *f = s_fopen (POCSAGLISTNAME, "lrt");
  if (f && seek_list (f, 0, pocsag_seek_server, name, ""))
  { fgets (s, 255, f);
    rm_crlf (s);
    parse_listheader (s, &servername, &description);
    if (longformat) putf ("Name of the server: %s\n", servername);
    if (*description)
      if (longformat) putf ("Description: %s\n", description);
      else putf ("Description of the server: %s\n", description);
    while (fgets (s, 50, f))
    { rm_crlf (s);
      if (*s != ' ') break;
      { userc++;
        while (*s == ' ') strcpy (s, s+1);
        if (strlen (s) > maxlen) maxlen = strlen (s);
      }
    }
    if (userc)
    { maxlen += 2; // for the 0-byte and the user-byte
      rewind (f);
      seek_list (f, 0, pocsag_seek_server, name, "");
      userlist = (char *) t_malloc (maxlen * (userc), "pocs");
      fgets (s, 255, f);
      for (i = 0; i < userc; i++)
      { fgets (s, 50, f);
        rm_crlf (s);
        if (s[1] == ' ') *(userlist + (i * maxlen)) = 0;
        else *(userlist + (i * maxlen)) = 1;
        while (*s == ' ') strcpy (s, s+1);
        strcpy (userlist + (i * maxlen) + 1, s);
      }
      qsort (userlist, userc, maxlen, (int(*)(const void *, const void *))strcmp);
      cols = 79 / (maxlen - 1);
      sprintf (format, "%%-%ds", maxlen - 1);
      if (userc)
      { putf ("Users (%d):\n", userc);
        row = 1;
        for (i = 0; i < userc; i++)
        { if ( ! (i % cols) && i)
          { putf ("\n");
            row++;
            //if(!longformat && row==6) //"
            //{ putf("(Not all listed)");
            //  break;
            //}
          }
          putf (format, userlist + (i * maxlen) + 1);
        }
        putf ("\n");
      }
      t_free (userlist);
    }
    s_fclose (f);
  }
}

/*---------------------------------------------------------------------------*/

void pocsagserv::execute (char *command)
//*************************************************************************
//
//  Executes an user-command destined to the server
//  list server subsystem
//
//*************************************************************************
{ if ( ! m.pocsaglistserv)
  { putf ("Sorry, pocsag server not enabled.\n");
    return;
  }
  char *befbuf;
  char *para2;
  int  i, callcount;
  char callpos[MAXPARSE];
  char user[CALLSSID+1];
  char usercall[CALLSSID+1];
  int longform = 0;
  befbuf = command;
  static char *beftab[] =
    {  "NEWLIST", "+L","DELLIST", "-L",
       "DESCRIPTION",
       "ADDUSER","+U", "DELUSER", "-U",
       "INFO", "LIST",
       "SUBSCRIBE", "UNSUBSCRIBE",
       "HELP", "PAGE", NULL
    };
  enum befnum
    { unsinn,
      newlist, newlist_, dellist, dellist_,
      description,
      adduser, adduser_, deluser, deluser_,
      info, list,
      subscribe, unsubscribe,
      help, page
    } cmd = unsinn;
  cmd = (befnum) readcmd (beftab, &befbuf, 0);
  befbuf += blkill (befbuf);
  switch (cmd)
  {
  case newlist:
  case newlist_:
    if ( ! *befbuf /*|| strlen (befbuf) > 20*/ || ! mbcallok (befbuf))
    { putf ("Syntax: POcsagserver +L <server_call>\n");
      break;
    }
    strupr (befbuf);
    modify_list (pocsag_createlist, befbuf, "");
    break;
  case dellist:
  case dellist_:
    if ( ! *befbuf)
    { putf ("Syntax: POcsagserver -L <server_call>\n");
      break;
    }
    strupr (befbuf);
    modify_list (pocsag_deletelist, befbuf, "");
    break;
  case description:
    if ( ! strchr (befbuf, ' '))
    { putf ("Syntax: POcsagserver DEScription <server_call> <text>\n");
      break;
    }
    para2 = strchr (befbuf, ' ') + 1;
    if (strchr (befbuf, ' ')) *strchr (befbuf, ' ') = 0;
    strupr (befbuf);
    modify_list (pocsag_setdescription, befbuf, para2);
    break;
  case adduser:
  case adduser_:
    strupr (befbuf);
    callcount = parseline (befbuf, callpos);
    if (callcount < 2 || callcount >= MAXPARSE)
    { putf ("Syntax: POcsagserver +U <server_call> <user_call>\n");
      break;
    }
    for (i = 1; i < callcount; i++)
      modify_list (pocsag_adduser, befbuf, befbuf + callpos[i]);
    break;
  case deluser:
  case deluser_:
    strupr (befbuf);
    callcount = parseline (befbuf, callpos);
    if (callcount < 2 || callcount >= MAXPARSE)
    { putf ("Syntax: POcsacserver -U <server_call> <user_call>\n");
      break;
    }
    for (i = 1; i < callcount; i++)
      modify_list (pocsag_deleteuser, befbuf, befbuf + callpos[i]);
    break;
  case info: longform = 1;
  case list:
    if (*befbuf)
    { strupr (befbuf);
      show_info (befbuf, longform);
    }
    else list_serverlists();
    break;
  case subscribe:
    if ( ! *befbuf)
    { putf ("Syntax: POcsagserver Subscribe <server_call>\n");
      break;
    }
    strupr (befbuf);
    modify_list (pocsag_subscribe, befbuf, u->call);
    break;
  case unsubscribe:
    if ( ! *befbuf)
    { putf ("Syntax: POcsagserver Unsubscribe <server_call>\n");
      break;
    }
    strupr (befbuf);
    modify_list (pocsag_unsubscribe, befbuf, u->call);
    break;
  case help:
    if (*befbuf) mbreadhelp (befbuf);
    else mbreadhelp ("pocsag");
     //readtext("mahelp");
    break;
  case page:
    para2 = nextword (befbuf, usercall, CALLSSID);
    if (*para2)
    {
      //do not sema-lock here, this info is read during distribution!
      FILE *f = s_fopen (POCSAGLISTNAME, "lrt");
      if (f)
      {
        i = 0;
        strupr (usercall);
        strcpy (b->at, usercall);
        while (seek_list (f, 0, pocsag_seek_entry, b->at, user))
        {
          char tempfilename[FNAMELEN+1];
          FILE *F;
          sprintf (tempfilename, TEMPPATH "/%s", time2filename (0));
          strlwr (tempfilename);
          if ( ! (F = s_fopen (tempfilename, "swt")))
          { trace (serious, "pocsagsv", "fopen %s errno=%d", tempfilename, errno);
            return;
          }
          fprintf (F, "SP P @ %s\nMessage for %s\n", b->at, usercall);
          fprintf (F, "FROM  %s\n", u->call);
          fprintf (F, "TO    %s\n", user);
          fprintf (F, "TEXT  %s\n", para2 );
          fprintf (F, "nnnn\nimpdel\n");
          s_fclose (F);
          mkboard ("/", "P", 0);
          fork (P_BACK | P_MAIL, 0, mbimport, tempfilename); //import it as mail
          i++;
          strcpy (b->at, usercall);
        }
        if (i == 1) putf (ms (m_messagewillbe), ms (m_stored));
        else if (i > 1) putf (ms (m_messageswillbe), i, ms (m_stored));
             else putf ("No user %s in the server list.\n", usercall);
        s_fclose (f);
      }
      else putf ("No server active.\n");
    }
    else
    { putf ("Syntax: POcsacserver Page <call> <short text>\n");
      break;
    }
    break;
  default:
      putf ("Syntax: POcsagserver +L | -L | +U | -U | I | P | S | U\n");
      //readtext("pochelp");
    break;
  }
}

/*---------------------------------------------------------------------------*/

void pocsagserv::examine_mail (void)
//*************************************************************************
//
//  Checks, if a mail is destinated to a user of a pocsag server
//  and processes the mail (called within send.cpp)
//
//*************************************************************************
{ char username[DIRLEN+1];
  char user[CALLSSID+1];
  char servername[DIRLEN+1];
  char tempfilename[FNAMELEN+1];
  char mailfilename[FNAMELEN+1];
  FILE *serverfile;
  FILE *mailfile;
  FILE *F;

//trace (replog,"examine_mail", "starting pocsag server");
  strcpy (username, b->ziel);
  strcpy (servername, username);
  strcpy (mailfilename, b->mailpath);
  strcpy (user, b->ziel);
  waitfor (e_ticsfull);
  lastcmd ("Pocsag list server");
  strcpy (b->uplink, "Pocsag");
  strcpy (t->name, ".");
  b->forwarding = fwd_none;
//trace(report,"pocsagsv","lock 3096");
  while ( ! sema_lock (POCSAGSEMA)) wdelay(3096);
  // Keine Server-Datei
  if ( ! (serverfile = s_fopen (POCSAGLISTNAME, "srt"))) return;
  while (seek_list (serverfile, 0, pocsag_seek_entry, servername, user))
  {
    sprintf (tempfilename, TEMPPATH "/%s", time2filename (0));
    strlwr (tempfilename);
    if ( ! (F = s_fopen (tempfilename, "swt")))
    { trace (serious,"pocsagsv","fopen %s errno=%d", tempfilename, errno);
      return;
    }
    mailfile = s_fopen (mailfilename, "srt");
    fgets (b->line, BUFLEN, mailfile);          // kopf-zeile
    mbsend_parse (b->line, 0);
    fgets (b->line, BUFLEN, mailfile);          // forward-zeile
    fgets (b->line, BUFLEN, mailfile);          // read-zeile
    fgets (b->betreff, BETREFFLEN, mailfile);   // titel-zeile
    s_fclose (mailfile);
    fprintf (F, "SP P @ %s\nMail for %s\n", servername, b->ziel);
    fprintf (F, "FROM  %s\n", b->herkunft);
    fprintf (F, "TO    %s\n", user);
    fprintf (F, "AT    %s\n", b->at);
    fprintf (F, "BID   %s\n", b->bid);
    fprintf (F, "LT   #%i\n", b->lifetime);
    fprintf (F, "BYTES %li\n", b->bytes);
    fprintf (F, "TITEL ");
    switch (b->conttype)
      { case '6':   fprintf (F, "(7-) "); break;
        case '7':   fprintf (F, "(7+) "); break;
        case '8':   fprintf (F, "(7inf) "); break;
        case '9':   fprintf (F, "(7txt) "); break;
        case 'H':   fprintf (F, "(html) "); break;
        default:    if (b->binstart) fprintf (F, "(BIN) ");
      }
    fprintf (F, "%s\n", b->betreff);
    fprintf (F,"nnnn\nimpdel\n");
    s_fclose (F);
    mkboard ("/", "P", 0);
    mbimport (tempfilename);
    xunlink (tempfilename);
    strcpy (servername, username);
  }
  s_fclose (serverfile);
//trace(report,"pocsagsv","unlock 3096/4");
  sema_unlock (POCSAGSEMA);
}

/*---------------------------------------------------------------------------*/
#endif
